<?php

namespace App\Classes\Modules\PerfexCRM\Services;

use Illuminate\Support\Facades\Http;
use App\Classes\Exceptions\MalformedRequestException;
use Illuminate\Support\Facades\Log;

class FetchesPerfexCRMInvoice
{
    /**
     * @param string $clientId
     * @param string $invoicePrefix
     * @param string $invoiceNumber
     * @return null|object
     * @throws MalformedRequestException
     */
    public function execute(string $clientId, string $invoicePrefix, string $invoiceNumber) {
        try{
            $response = Http::withHeaders([
                'authtoken' => config('perfexcrm.api_key'),])
            ->get(config('perfexcrm.base_url').'/api/invoices/customsearch/'.$clientId.'/'.$invoicePrefix.'/'.$invoiceNumber);

            if($response->successful()){
                $data = $response->json();

                return (object) $data;
            }else{
                Log::channel('perfex_crm')->info($response);
                return null;
            }
        }catch(\Exception $exception){
            throw new MalformedRequestException('Unable to get correct response from Perfex CRM server: ' . $exception->getMessage());
        }
    }
}
